package com.nisum.task.controller;


import com.nisum.task.entity.BPN;
import com.nisum.task.service.FileUploadService;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import reactor.core.publisher.Flux;

import java.io.IOException;

@CrossOrigin(origins = "*")
@RestController
@RequestMapping("/file")
public class FileUploadController {

    @Autowired
    private FileUploadService fileUploadService;

//    @PostMapping("/uploadFile")
//    public Flux<BPN> uploadFile(@RequestParam("file") MultipartFile file) throws IOException {
//        log.info("file upload");
//        return fileUploadService.uploadFile(file);
//    }

    private static final Logger log = LoggerFactory.getLogger(FileUploadController.class);

    @PostMapping("/import")
    @ResponseStatus(HttpStatus.OK)
    public ResponseEntity<String> importFile(@RequestParam("file") MultipartFile file) {
        log.info("Received file: {}", file.getOriginalFilename());

        // You can perform further operations with the file, e.g., save it to the server
        // For demonstration purposes, just log the file details

        try {
            byte[] fileBytes = file.getBytes();
            // Perform operations with fileBytes as needed

            return ResponseEntity.ok("File uploaded successfully!");
        } catch (IOException e) {
            log.error("Error processing the file: {}", e.getMessage());
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body("Error processing the file.");
        }
    }
}
