package com.nisum.task.controller;

import com.nisum.task.entity.SMIC;
import com.nisum.task.service.SmicService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;


@CrossOrigin(origins = "*")
@Slf4j
@RestController
@RequestMapping("/smic")
public class SmicController {

    @Autowired
    private SmicService smicService;

    @PostMapping("/createSMIC")
    public Mono<SMIC> saveSMIC(@RequestBody SMIC smic) {
        log.info("save SMIC {}",smic);
        return smicService.saveSMIC(smic);
    }

    @GetMapping("/findById/{smicID}")
    public Mono<SMIC> getSMIC(@PathVariable String bpnID) {
        log.info("getSMIC {}",bpnID);
        return smicService.findById(Long.valueOf(bpnID));
    }

    @GetMapping("/findAll")
    public Flux<SMIC> findAllSMICs() {
        log.info("find all");
        return smicService.findAll();
    }

}
