package com.nisum.task.service;

import com.nisum.task.entity.SMIC;
import com.nisum.task.repository.SmicRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.Date;

@Service
public class SmicService {

    private static final String DELETE = "Deleted";
    private static final String BLOCK = "block";
    private static final String FORCE = "force";
    private static final String RECALL = "recall";

    @Autowired
    private SmicRepository smicRepository;

    public Mono<SMIC> saveSMIC(SMIC smic) {
        smic.setFirstEffectiveDate(new Date());
        smic.setCreatedTime(new Date());
        smic.setUpdatedTime(new Date());
        return smicRepository.save(smic);
    }

    public Mono<SMIC> findById(Long bpnId) {
        return smicRepository.findById(bpnId);
    }

    public Flux<SMIC> findAll() {
        return smicRepository.findAll();
    }

    private SMIC setAllFields(SMIC smicDB, SMIC uiSMIC, String message) {
        smicDB.setLasttEffectiveDate(uiSMIC.getLasttEffectiveDate());
        smicDB.setUpdatedTime(new Date());
        smicDB.setFac(uiSMIC.getFac());
        smicDB.setForceOptCd(uiSMIC.getForceOptCd());
        return smicDB;
    }
}
